{TODO:
  add supply client info callback support
  fix user supplied callback address callback
  Versioning agreement between dll an application
  }

{$C FIXED PRELOAD PERMANENT}
{$DEFINE LIB}
{$IFDEF LIB}
library  Csl_cs;
{$ELSE}
program  Csl_cs;
{$ENDIF}

uses
  Sysutils,
  WinDos in '\DELPHI\SOURCE\RTL70\WINDOS.PAS',
  Classes in '\DELPHI\SOURCE\VCL\CLASSES.PAS',
  WinProcs in '\DELPHI\SOURCE\RTL\WIN\WINPROCS.PAS',
  WinTypes in '\DELPHI\SOURCE\RTL\WIN\WINTYPES.PAS',
  Extracs2 in 'EXTRACS2.PAS',
  Main in 'MAIN.PAS',
  Pcm in 'PCM.PAS',
  Utils in 'UTILS.PAS',
  cs2 in 'CS2.PAS',
  Cstypes2 in 'CSTYPES2.PAS',
  Dpmi in 'DPMI.PAS',
  Realmode in 'REALMODE.PAS',
  P16mode in 'P16MODE.PAS',
  Win95 in 'WIN95.PAS',
  Callback in 'CALLBACK.PAS',
  Dllini in 'DLLINI.PAS';

{$G main, pcm, windos, utils, cs2, extracs2 cstypes2}

{$IFDEF LIB}
exports
  CallCardServices, RegisterClient, DeregisterClient, Style, AllStyles, MTD, Status,
  GetConfigurationInfo, RequestConfiguration, ReleaseConfiguration,
  GetClientInfo, GetClientInfoDefault, GetFirstClient, GetNextClient, OpenMemory,
  WriteMemory,
  CloseMemory, ReadMemory, CopyToCard, CopyFromCard, IsWriteProtect,
  RequestWindow, ReleaseWindow, FindResource, MapMemPage, ReleaseExclusiveAccess,
  RequestExclusiveAccess, GetStatus, CardPresent, ValidateCis, GetCardServicesInfo,
  GetCardServicesInfoDefault, SocketCount,
  AdjustResourceInfo, CardStatusToBatteryLevel, CheckBattery, SetEventMask,
  DefaultCallback,
  CSDateToDate,EncodeCSDate,bcd2version,
  DLL_VERSION, DLL_INFO, RunSetup,
  checkVersion,
  TimerCallback,
  CheckInstallation,
  SearchInstallation,
  MapCardServices;
{$ENDIF}

begin
  Log('CSL-CS Start');
  try
    CSType:=CheckInstallation(CSType);
  except
    On E: Exception do begin
      Log('Some Exception: '+E.Message);
      CSType:=csNone;
      Raise;
    end else
      Raise;
  end;
end.
