Unit Xpaslib;
{ A few routines which didn't appear to be in pascal }

interface

uses sysutils;
{uses crt,dos;}

type
  longword = longint;

{function bcd2string(BCD: Word) : string;
function bcd2int(BCD: Word) : integer;
Function Dec2Hex(dec : longword ) : string;
procedure Pause(message: string);
{ Displays a message and waits for a key to be pushed }
function SubCA(Cfrom : word; CLen : word; Carray : array of char):string;
{ Returns part of a character array as a string }
procedure ToCA(cto : word; var Carray : array of char; text : string);
{ writes a string to part of a character array }

implementation

function bcd2int(BCD: Word) : integer;
var
     TBCD : integer;
     i : integer;
     t : integer;
     tens : integer;
     decimal : integer;

begin
     tens:=1;
     decimal:=0;
     TBCD:=BCD;
     for i:=0 to 3 do { for each digit }
     begin
       decimal:=decimal+tens*(TBCD MOD 16);
       TBCD:=TBCD DIV 16;
       tens:=tens*10;
     end;
     bcd2int:=decimal
end;  { bcd2string }

function bcd2string(BCD: Word) : string;
var
     digits : string[5];
     decimal : integer;
begin
     decimal:=bcd2int(BCD);
     STR(decimal,digits);
     bcd2string:=digits;
end;

function SubCA(Cfrom : word; CLen : word; Carray : array of char):string;
var
     buffer : string;

begin
     if clen>255 then
       SubCA:='Error - length too long'
     { what an evil hack (returning the wrong value) }
     { - but it would help with debugging.... }
     else
       begin
       buffer[0]:=chr(CLen);
       for Clen := 1 to CLen+1 do
       begin
         buffer[Clen]:=Carray[Cfrom];
         CFrom:=CFrom+1;
       end;
       SubCA:=buffer;
     end;
end;

Function Dec2Hex(dec : longword ) : string;
const
  hexchars: array [0..$F] of char = '0123456789ABCDEF';

var
  dummy : byte;
  buffer : string[9];
  digit : string[1];

begin
     buffer:='';
     while dec > 0 do
       begin
       digit:=hexchars[dec mod 16];
       buffer:=concat(digit,buffer);
       dec:=dec div 16;
       end;
     Dec2Hex:=buffer;
end;


procedure ToCA(cto : word; var Carray : array of char; text : string);
var
   counter : integer;
{$R-}
begin
     for counter:=1 to length(text) do
     begin
       carray[cto+counter-1]:=text[counter];
     end;
     carray[cto+length(text)]:=chr(0);
{$R+}
end;

procedure Pause(message: string);
var
  dummy : char;

begin
  writeln(message);
end;

end.
