program Pccsetup;

uses
  Forms,
  sysutils,
  Clients in 'CLIENTS.PAS' {Setup},
  About in 'ABOUT.PAS' {AboutBox},
  Cardserv in '\projects\PCCARD\CARDSERV.PAS',
  Cstypes2 in '\projects\PCCARD\CSTYPES2.PAS',
  Utils in '\projects\PCCARD\UTILS.PAS',
  Modify in 'MODIFY.PAS' {ExtraDrivers},
  WinDos in '\DELPHI\SOURCE\RTL70\WINDOS.PAS',
  First in 'FIRST.PAS' {FirstForm},
  Classes in '\DELPHI\SOURCE\VCL\CLASSES.PAS',
  Previnst in 'PREVINST.PAS',
  Dllini in '\projects\PCCARD\DLLINI.PAS';

{$R *.RES}

begin
  Application.HelpFile := 'C:\DELPHI\PCCARD\UTILS\PCCARD.HLP';
  With Application do
    HelpFile := ExtractFilePath(ExeName)+ExtractFileName(HelpFile);
  if hPrevInst<>0 then  {Is there a previous instance?}
    GotoPreviousInstance  {Yes, so find and activate it.}
  else If WantSetup then begin
  Application.Title := 'PCCard Support Setup';
  Application.CreateForm(TFirstForm, FirstForm);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.Run;
  end;
end.
 